precision highp float;

varying vec2 textureCoordinate;

uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;

uniform highp vec2 iResolution;

uniform float progress;

uniform highp vec4 iRanges[10];
uniform highp vec4 iCuts[10];
uniform int iRangeNum;

void main() {
    highp vec2 uv = textureCoordinate;

    highp vec4 color1 = texture2D(iChannel0, uv);
    highp vec4 color2 = texture2D(iChannel1, uv);

    float xx = 1.0;
    float t = progress;
    float k = 1. / float(iRangeNum);
    for (int i = 0; i < iRangeNum; i++) {
        float a = (t - k * float(i)) / k;
        a = clamp(a, 0.0, 1.0);
        highp vec4 r = iRanges[i];
        highp vec4 c = iCuts[i];
        if (uv.x > r.x + c.x * a &&
        uv.x <= r.y + c.y * a &&
        uv.y > r.z + c.z * a &&
        uv.y <= r.w + c.w * a) {
            xx = 0.0;
            break;
        }
    }

    gl_FragColor = mix(color2, color1, xx);
}